// 
// FamilyTest.cs
// Author: Loren Bandiera
// Copyright 2004-2006 MMG Security, Inc.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//

using System;
using System.Collections;
using System.Diagnostics;
using System.IO;
using System.Text;
using System.Xml;

namespace Sussen.Oval.Independent
{
	public class FamilyTest : Test
	{
		public FamilyTest ()
		{
		}		

		public override CollectedItem[] Run (TestElement testElement, ObjectElement objectElement)
		{
			ArrayList items = new ArrayList ();
						
			items.Add (CollectData ());
			
			return (CollectedItem[]) items.ToArray (typeof (CollectedItem));
		}

		CollectedItem CollectData ()
		{
			CollectedItem item = new CollectedItem ("family_item", 0, Vocabulary.INDEPENDENT_NAMESPACE, Flags.Complete);
			
			// FIXME: How do I determine unix vs. linux?
			string versionString = Environment.OSVersion.ToString();
			versionString = versionString.ToLower ();
			string famName = null;

			if (versionString.StartsWith ("unix"))
				famName = "unix";
			else if (versionString.StartsWith ("microsoft"))
				famName = "windows";
			else
				famName = "unknown";
			
			item.AddItem (new ItemEntity ("family", famName, OvalDataTypes.StringType, StatusFlags.Exists, false));
			return item;
		}
	}
}
