//
// FileMD5TestTest.cs - NUnit Test Cases for Sussen.Oval.Unix
//
// Loren Bandiera (lorenb@mmgsecurity.com)
//
// Copyright (C) MMG Security, Inc.
// 

using System;
using System.Xml;
using NUnit.Framework;
using Sussen.Oval;
using Sussen.Oval.Independent;

namespace SussenTests.Oval.Independent
{
	[TestFixture]
	public class FileMD5TestTest
	{
		FileMD5Test ft;
		ObjectElement oe;

		[SetUp]
		public void SetUp()
		{
			ft = new FileMD5Test ();

			oe = new ObjectElement ("filemd5_object", "oval:org.mmgsecurity:obj:1", "1", "");

			EntityObject eo1 = new EntityObject ("path", ".", Operations.Equals, OvalDataTypes.StringType, Checks.All);
			oe.Entities [eo1.Name] = eo1;

			EntityObject eo2 = new EntityObject ("filename", "oval.v5.test.definitions.xml", Operations.Equals, OvalDataTypes.StringType, Checks.All);
			oe.Entities [eo2.Name] = eo2;
		}

		[TearDown]
		public void TearDown ()
		{
			ft = null;
			oe = null;
		}

		[Test]
		public void TestFileMD5Test ()
		{
			CollectedItem[] testResults;
			testResults = ft.Run (null, oe);

			foreach (CollectedItem c in testResults) {
				ItemEntity ie = c.Items[0];
				if (ie.Name == "md5")
					Assert.AreEqual ("ef8943c3ebe61d3123c83b613b56739b", ie.Value);
			}
		}
	}
}
