//
// InterpreterTest.cs - NUnit Test Cases for Sussen.Oval.Unix
//
// Loren Bandiera (lorenb@mmgsecurity.com)
//
// Copyright (C) MMG Security, Inc.
// 

using System;
using System.IO;
using System.Xml;
using NUnit.Framework;
using Sussen.Oval;

namespace SussenTests.Oval.Unix
{
	[TestFixture]
	public class InterpreterTest
	{
		Config config;

		[SetUp]
		public void SetUp()
		{
			config = new Config ("linux");
			config.DefinitionsFile = "oval.v5.test.definitions.xml";
			config.VerifyXML = false;
		}

		[TearDown]
		public void TearDown ()
		{
			config = null;
		}

		[Test]
		public void TestInterpreterTest ()
		{
			Interpreter i = new Interpreter (config);
			i.CollectData ();
			i.AnalyzeData ();
		}

		[Test]
		public void TestInterpreterAnalyzeDefinition ()
		{
			StreamReader sr = new StreamReader("definitionString.xml");
			string rawData = sr.ReadToEnd ();


			Interpreter i = new Interpreter ();
			i.CurrentConfiguration = config;
			string res = i.AnalyzeDefinition (rawData);

			Assert.IsNotNull (res);
		}
	}
}
