CREATE TABLE agents (
  id varchar(50) NOT NULL PRIMARY KEY,
  name varchar(200) NOT NULL
);

CREATE TABLE scans (
  id int(11) NOT NULL auto_increment PRIMARY KEY,
  agent varchar(50) NOT NULL,
  created TIMESTAMP DEFAULT NOW(),
  FOREIGN KEY (agent) REFERENCES agents (id) ON DELETE CASCADE
);

CREATE TABLE xml_results (
  scan_id int(11) NOT NULL,
  data longtext,
  FOREIGN KEY (scan_id) REFERENCES scans (id) ON DELETE CASCADE
);

CREATE TABLE definition_results (
  scan_id int(11) NOT NULL,
  agent_id varchar(50) NOT NULL,
  oval_id varchar(15),
  class_type varchar(25),
  affected_family varchar(100),
  affected_product varchar(100),
  description text,
  reference varchar(50),
  reference_source varchar(50),
  criteria_result int (1),
  FOREIGN KEY (scan_id) REFERENCES scans (id) ON DELETE CASCADE,
  FOREIGN KEY (agent_id) REFERENCES agents (id) ON DELETE CASCADE
);
