<?php

class OvalResults {

	private function getDefinitionData ($def, $child) {

		switch ($child->nodeName) {

		case "affected":
			$def->affected_family = $child->attributes->getNamedItem("family")->nodeValue;

			foreach ($child->childNodes as $aff_child) {

				if ($aff_child->nodeName == "platform") { 
					$def->affected_platform = $aff_child->nodeValue;
				} else if ($aff_child->nodeName == "product") {
					$def->affected_product = $aff_child->nodeValue;
				}
			}
			break;

		case "description":
			$def->description = $child->nodeValue;
			break;

		case "reference":
			$def->reference_source = $child->attributes->getNamedItem("source")->nodeValue;
			$def->reference = $child->nodeValue;
			break;

		case "criteria":
			$def->criteria_result = $child->attributes->getNamedItem("result")->nodeValue;
			break;

		}
	}

	private function parseDefinition ($def, $node) {

		$def->oval_id = $node->attributes->getNamedItem("id")->nodeValue;
		$def->class_type = $node->attributes->getNamedItem("class")->nodeValue;

		foreach ($node->childNodes as $child) {
			$this->getDefinitionData ($def, $child);
		}
	}

	function parseResults ($scanID, $agentID, $xml_string) {

		$xml = new XMLReader;
		$xml->XML ($xml_string);

		while ($xml->read ()) {

			if ($xml->name == "definition" && $xml->nodeType == 1) {

				$node = $xml->expand ();

				$def = new DataObjects_DefinitionResult;
				$def->scan_id = $scanID;
				$def->agent_id = $agentID;

				$this->parseDefinition ($def, $node);

				$res = $def->insert ();

				if (PEAR::isError ($res)) {
					die ("Unable to save definition results");
				}
			}
		}
	}
}

?>
