<?php

require_once 'config.php';
require_once 'db.php';
require_once 'oval.php';

function registerAgent ($hostName) {

	if (is_null ($hostName)) {
		return "Unable to register agent.";
	}

	$agent = new DataObjects_Agent;
	$agent->id = md5(uniqid(microtime(), 1)) . getmypid();
	$agent->name = $hostName;
	$res = $agent->insert ();

	if (PEAR::isError ($res)) {
		die ("Unable to register agent");
	}

	return $agent->id;
}

function sendResults ($agentID, $resultData) {

	if (is_null ($resultData) or is_null ($agentID)) {
		return "Unable to save results.";
	}

	$agent = new DataObjects_Agent;
	$agent->id = $agentID;
	$num = $agent->find ()

	if (PEAR::isError ($num) or $num <= 0) {
		return ("Invalid agent ID");
	}

	$xml_string = base64_decode ($resultData);

	$scan = new DataObjects_Scan;
	$scan->id = 0;
	$scan->agent = $agentID;
	$scanID = $scan->insert ();

	if (PEAR::isError ($scanID)) {
		return ("Unable to save scan");
	}

	$xml_results = new DataObjects_XmlResult;
	$xml_results->scan_id = $scanID;
	$xml_results->data = $xml_string;
	$res = $xml_results->insert ();

	if (PEAR::isError ($res)) {
		return ("Unable to save scan xml");
	}

	$oval = new OvalResults;
	$oval->parseResults ($scanID, $agentID, $xml_string);

	return "results saved.";
}

$server = new SoapServer ("sussen.wsdl");
$server->addFunction ("sendResults");
$server->addFunction ("registerAgent");
$server->handle();

?>
